/* kfortune_zone.h
 *
 * Pieter Eendebak <pte@ddsw.nl>
 *
 */

#ifndef KFORTUNE_ZONE_H
#define KFORTUNE_ZONE_H

#include "includes.h"
#include <qclipbrd.h>
#include <qdragobject.h>
#include "flabel.h"
#include "fhtml.h"

class KFortune ;

/**
 * A normal QLabel could be used to display fortunes,
 * but we want html-fortunes...
 *
 * @short Class for displaying fortunes.
 * @author Pieter Eendebak <pte@ddsw.nl>
 */
class KFortuneZone : public QWidget
{
	friend KFortune ;

	Q_OBJECT

public:
	KFortuneZone( QWidget *parent, const char *name=0 ) ;
	~KFortuneZone() ;

	void setFortuneText( QString ) ;
	QString getFortuneText() ;

public slots:
	void setFont( QFont & ) ;
	void copyFortuneToClipboard() ;

protected slots:
	/* These are redefined to make them act as slots
	 */
	virtual void mousePressEvent( QMouseEvent * ) ;
	virtual void mouseReleaseEvent( QMouseEvent * ) ;
	virtual void mouseMoveEvent( QMouseEvent * ) ;
	void leaveEvent( QEvent * ) ;

	void resizeEvent( QResizeEvent * ) ;
	void resizeEvent() ;
signals:
	void notifyMousePressEvent( QMouseEvent * ) ;

protected:
	FLabel *display_normal ;
	FHtml *display_html ;

	QString text ;
	bool html ;

	/* for DND */
	bool mouse_pressed ;
	/* for cut&paste */
	QClipboard *clipboard ;
};


#endif		
